#include <acknex.h>
#include <default.c>

#include "PP_Helper.c"

BMAP* camera_clean;
BMAP* depthtex;

MATERIAL* matBlackout =
{
	effect = "Blackout.fx";
}

MATERIAL* matBloomAdd =
{
	effect = "BloomAdd.fx";
}

MATERIAL* matBlurH =
{
	effect = "Blur.fx";
}

MATERIAL* matBlurV =
{
	effect = "Blur.fx";
}

MATERIAL* matRadialBlur =
{
	effect = "RadialBlur.fx";
}

MATERIAL* matDepth =
{
	effect = "Depth.fx";
}

MATERIAL* matDoF =
{
	effect = "DoF.fx";
}

void main()
{
	level_load("Terrain.hmp");
	
	camera_clean = bmap_createblack(screen_size.x, screen_size.y, 24);
	camera.bmap = camera_clean;
	
	PP_Add(matBlurH, camera, NULL);
	PP_Add(matBlurV, camera, NULL);
	PP_Add(matDoF, camera, NULL);
	
	VIEW* tempview = PP_LastView(camera);
	tempview.bmap = camera_clean;
	
	PP_Add(matBlackout, camera, NULL);
	PP_Add(matBlurH, camera, NULL);
	PP_Add(matBlurV, camera, NULL);
	PP_Add(matBloomAdd, camera, NULL);
//	PP_Add(matRadialBlur, camera, NULL);
	
	matBlurH.skill1 = floatv(1);
	matBlurH.skill2 = floatv(0);
	
	matBlurV.skill1 = floatv(0);
	matBlurV.skill2 = floatv(1);
	
	matDoF.skill1 = floatv(100);
	matDoF.skill2 = floatv(50);
	matDoF.skill3 = floatd(1, 100);
	
	VIEW* depthview = view_create(-1);
	set(depthview, VISIBLE);
	depthview.material = matDepth;
	
	depthtex = bmap_createblack(screen_size.x, screen_size.y, 14);
	depthview.bmap = depthtex;
	
	while(1)
	{
		vec_set(depthview.x, camera.x);
		vec_set(depthview.pan, camera.pan);
		depthview.size_x = camera.size_x;
		depthview.size_y = camera.size_y;
		depthview.aspect = camera.aspect;
		depthview.clip_far = camera.clip_far;
		
		wait(1);
	}
}